/*
 * uData API
 * uData API
 *
 * OpenAPI spec version: 1.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.asso.ladoxa.datagouv.models;

import com.fasterxml.jackson.annotation.JsonProperty;
import io.swagger.annotations.ApiModelProperty;

import java.util.ArrayList;
import java.util.List;
import java.util.Objects;

/**
 * License
 */

public class License {
  @JsonProperty("alternate_titles")
  private List<String> alternateTitles = null;

  @JsonProperty("alternate_urls")
  private List<String> alternateUrls = null;

  @JsonProperty("flags")
  private List<String> flags = null;

  @JsonProperty("id")
  private String id = null;

  @JsonProperty("maintainer")
  private String maintainer = null;

  @JsonProperty("title")
  private String title = null;

  @JsonProperty("url")
  private String url = null;

  public License alternateTitles(List<String> alternateTitles) {
    this.alternateTitles = alternateTitles;
    return this;
  }

  public License addAlternateTitlesItem(String alternateTitlesItem) {
    if (this.alternateTitles == null) {
      this.alternateTitles = new ArrayList<String>();
    }
    this.alternateTitles.add(alternateTitlesItem);
    return this;
  }

   /**
   * Same alternative known titles (improve rematch)
   * @return alternateTitles
  **/
  @ApiModelProperty(value = "Same alternative known titles (improve rematch)")
  public List<String> getAlternateTitles() {
    return alternateTitles;
  }

  public void setAlternateTitles(List<String> alternateTitles) {
    this.alternateTitles = alternateTitles;
  }

  public License alternateUrls(List<String> alternateUrls) {
    this.alternateUrls = alternateUrls;
    return this;
  }

  public License addAlternateUrlsItem(String alternateUrlsItem) {
    if (this.alternateUrls == null) {
      this.alternateUrls = new ArrayList<String>();
    }
    this.alternateUrls.add(alternateUrlsItem);
    return this;
  }

   /**
   * Same alternative known URLs (improve rematch)
   * @return alternateUrls
  **/
  @ApiModelProperty(value = "Same alternative known URLs (improve rematch)")
  public List<String> getAlternateUrls() {
    return alternateUrls;
  }

  public void setAlternateUrls(List<String> alternateUrls) {
    this.alternateUrls = alternateUrls;
  }

  public License flags(List<String> flags) {
    this.flags = flags;
    return this;
  }

  public License addFlagsItem(String flagsItem) {
    if (this.flags == null) {
      this.flags = new ArrayList<String>();
    }
    this.flags.add(flagsItem);
    return this;
  }

   /**
   * Some arbitry flags
   * @return flags
  **/
  @ApiModelProperty(value = "Some arbitry flags")
  public List<String> getFlags() {
    return flags;
  }

  public void setFlags(List<String> flags) {
    this.flags = flags;
  }

  public License id(String id) {
    this.id = id;
    return this;
  }

   /**
   * The license identifier
   * @return id
  **/
  @ApiModelProperty(required = true, value = "The license identifier")
  public String getId() {
    return id;
  }

  public void setId(String id) {
    this.id = id;
  }

  public License maintainer(String maintainer) {
    this.maintainer = maintainer;
    return this;
  }

   /**
   * The license official maintainer
   * @return maintainer
  **/
  @ApiModelProperty(value = "The license official maintainer")
  public String getMaintainer() {
    return maintainer;
  }

  public void setMaintainer(String maintainer) {
    this.maintainer = maintainer;
  }

  public License title(String title) {
    this.title = title;
    return this;
  }

   /**
   * The resource title
   * @return title
  **/
  @ApiModelProperty(required = true, value = "The resource title")
  public String getTitle() {
    return title;
  }

  public void setTitle(String title) {
    this.title = title;
  }

  public License url(String url) {
    this.url = url;
    return this;
  }

   /**
   * The license official URL
   * @return url
  **/
  @ApiModelProperty(value = "The license official URL")
  public String getUrl() {
    return url;
  }

  public void setUrl(String url) {
    this.url = url;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    License license = (License) o;
    return Objects.equals(this.alternateTitles, license.alternateTitles) &&
        Objects.equals(this.alternateUrls, license.alternateUrls) &&
        Objects.equals(this.flags, license.flags) &&
        Objects.equals(this.id, license.id) &&
        Objects.equals(this.maintainer, license.maintainer) &&
        Objects.equals(this.title, license.title) &&
        Objects.equals(this.url, license.url);
  }

  @Override
  public int hashCode() {
    return Objects.hash(alternateTitles, alternateUrls, flags, id, maintainer, title, url);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class License {\n");

    sb.append("    alternateTitles: ").append(toIndentedString(alternateTitles)).append("\n");
    sb.append("    alternateUrls: ").append(toIndentedString(alternateUrls)).append("\n");
    sb.append("    flags: ").append(toIndentedString(flags)).append("\n");
    sb.append("    id: ").append(toIndentedString(id)).append("\n");
    sb.append("    maintainer: ").append(toIndentedString(maintainer)).append("\n");
    sb.append("    title: ").append(toIndentedString(title)).append("\n");
    sb.append("    url: ").append(toIndentedString(url)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

